#include "twndw.h"

DEFINE_RESPONSE_TABLE1(TWndw,TFrameWindow)
	 EV_WM_LBUTTONDOWN,
	 EV_WM_MBUTTONDOWN,
	 EV_WM_RBUTTONDOWN,
	 EV_WM_MOUSEMOVE,
	 EV_WM_SYSCOMMAND,
	 EV_WM_ACTIVATE,
	 EV_WM_ACTIVATEAPP,
	 EV_WM_SYSKEYDOWN,
	 EV_WM_KEYDOWN,
END_RESPONSE_TABLE;

TWndw::TWndw (TWindow *parent, const char far *title,
  TWindow *client):TFrameWindow(parent, title, client)
{
  HKEY res;
  //         
  if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\FigureScreenSaver\\", 0,
					  KEY_QUERY_VALUE,&res)==ERROR_SUCCESS)
  {
		char numb[3];
		DWORD sizestr=3, sizemode=1;
		if (RegQueryValueEx(res, "Number", 0, NULL, (BYTE*)numb, &sizestr)==ERROR_SUCCESS)
		  Num=atoi(numb);
		else Num=20;
		if (RegQueryValueEx(res, "Mode", 0, NULL, (BYTE*)&mode, &sizemode)!=ERROR_SUCCESS)
		  mode=0;
		RegCloseKey(res);
  }
  else Num=20;

  randomize();
  GetCursorPos(mouseXY);//   
  ShowCursor(FALSE);// 
  Attr.Style = WS_POPUP;// 
  Attr.X = 0;
  Attr.Y = 0;
  Attr.W = GetSystemMetrics (SM_CXSCREEN);//
  Attr.H = GetSystemMetrics (SM_CYSCREEN);//     
  fff=new Figure_p[Num]; //       
  //        
  for(int i=0; i<Num;i++) fff[i]=new Figure(Attr.W/2, Attr.H/2,
				TColor(random(256), random(256),random(256)), 180-random(360));
  

}

TWndw::~TWndw ()
{
  ShowCursor(TRUE); // 
	 for(int i=0; i<Num;i++) delete fff[i]; //  - 
	 delete [] fff; //   - 
}

void TWndw::GetWindowClass (WNDCLASS &wndClass)
//,    
{
  TFrameWindow::GetWindowClass (wndClass);
  wndClass.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
}

char far *TWndw::GetClassName()
//,    
{
  return   "WindowsScreenSaverClass";
}

void TWndw::EvMouseMove(UINT, TPoint& point)
//,    
{
  //   ,      WM_CLOSE
  if (point != mouseXY) PostMessage(WM_CLOSE);
}

void TWndw::EvLButtonDown(UINT, TPoint&)
//,      
{
  PostMessage(WM_CLOSE);
}

void TWndw::EvMButtonDown(UINT, TPoint&)
//,      
{
  PostMessage(WM_CLOSE);
}

void TWndw::EvRButtonDown (UINT, TPoint&)
//,      
{
  PostMessage(WM_CLOSE);
}

void TWndw::EvActivate (UINT active, BOOL, HWND)
//,   / 
{
  if (!active) PostMessage (WM_CLOSE);
}

void TWndw::EvActivateApp (BOOL active, HTASK)
//,   /   
{
  if (!active) PostMessage (WM_CLOSE);
}

void TWndw::EvKeyDown(UINT, UINT, UINT)
{
  PostMessage(WM_CLOSE);
}

void TWndw::EvSysKeyDown(UINT, UINT, UINT)
//,     
{
  PostMessage(WM_CLOSE);
}

void TWndw::EvSysCommand(UINT cmdType, TPoint&)
//    
{
  if ((cmdType & 0xFFF0) != SC_SCREENSAVE) DefaultProcessing();
}

void TWndw::DoSaver()
//   
{
	TMemoryDC ddb; //   
	TClientDC ddd(HWindow); //    
	//    
	TRect ss = ddd.GetClipBox();
	TSize sz = ss.Size(); //   
	//      ,
	//    
	TBitmap bitmap(ddd, sz.cx, sz.cy, FALSE);
	ddb.SelectObject(bitmap); //     ddb
	//         
	if (mode) ddb.BitBlt(0, 0,  sz.cx, sz.cy,ddd, 0, 0);
	for(int i=0; i<Num;i++) fff[i]->Saver(ddb); //  
	//       
	ddd.BitBlt(0, 0,  sz.cx, sz.cy,ddb, 0, 0);
}
